Attribute VB_Name = "AbendLoggerModule"
'Large Portions of this code are Copyright (c) Microsoft Inc
'They are extracted from what are believed to be freely distributable libraries
'provided that they are only used in conjunction with MS Visual Basic or other Visual Studio Applications

'Large Portions of this code are Copyright (c) Novell Inc
'They are extracted from what are believed to be freely distributable libraries
'and example code which is available from the developer section of the Novell website

'The remaining code in this module is subject to the following license

'Copyright (c) 2001/9 Jim Champ/Surrey County Council
'All rights reserved.
'Developed by:       Jim Champ/Sara Day
'                        www.champwilde.f9.co.uk/idmphp/


'Permission is hereby granted, free of charge, to any person obtaining a
'copy of this software and associated documentation files (the
'"Software"), to deal with the Software without restriction, including
'without limitation the rights to use, copy, modify, merge, publish,
'distribute, sublicense, and/or sell copies of the Software, and to
'permit persons to whom the Software is furnished to do so, subject to
'the following conditions:

'Redistributions of source code must retain the above copyright
'notice, this list of conditions and the following disclaimers.

'Redistributions in binary form must reproduce the above
'copyright notice, this list of conditions and the following disclaimers
'in the documentation and/or other materials provided with the
'distribution.

'Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
'or promote products derived from this Software without specific prior
'written permission.
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
'OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
'ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.




Option Explicit

Global NDS_TREE As String

'Dim ccode As Long
Dim pConnHandle As Long
Dim rconnHandle As Long
Global ServerName As String

Global maxPRB As Double
Global minPRB As Double
Global curPRB As Double

Global orgCB As Long
Global curCB As Long
Global pctCb As Single

Global maxDCB As Long
Global minDCB As Long
Global curDCB As Long

Global ServerUptime As Long

Global maxSP As Long
Global minSP As Long
Global CurSp As Long

Dim NumSet As Integer

Global SetArrayStore()
Global ServersInTree()
Global UsersinTree()
Global VolList(255, 2)
Global VolCount As Integer


Global ServerCount As Integer
Global UserCount As Long

Global NWver As Single

Public Type Tree_Name_T
    tname(64) As Byte
End Type

Type TToken
    buf(31) As Byte
End Type
Public Const DEFAULT_MESSAGE_LEN = 4096
Public Const MAX_MESSAGE_LEN = 64512

Public Const NO_MORE_ITERATIONS = -1
Public Const DCK_NAME_CONTEXT = 3
Public Const DCK_TREE_NAME = 11
Public Const DSV_SEARCH_FILTER = 28

Public Const DS_SEARCH_ENTRY = 0
Public Const DS_SEARCH_SUBORDINATES = 1
Public Const DS_SEARCH_SUBTREE = 2

Public Const DS_ROOT_NAME = "[Root]"

Public Const DS_ATTRIBUTE_NAMES = &H0
Public Const DS_ATTRIBUTE_VALUES = &H1

Public Const SYN_UNKNOWN = 0
Public Const SYN_DIST_NAME = 1
Public Const SYN_CE_STRING = 2
Public Const SYN_CI_STRING = 3
Public Const SYN_PR_STRING = 4
Public Const SYN_NU_STRING = 5
Public Const SYN_CI_LIST = 6
Public Const SYN_BOOLEAN = 7
Public Const SYN_INTEGER = 8
Public Const SYN_OCTET_STRING = 9
Public Const SYN_TEL_NUMBER = 10
Public Const SYN_FAX_NUMBER = 11
Public Const SYN_NET_ADDRESS = 12
Public Const SYN_OCTET_LIST = 13
Public Const SYN_EMAIL_ADDRESS = 14
Public Const SYN_PATH = 15
Public Const SYN_REPLICA_POINTER = 16
Public Const SYN_OBJECT_ACL = 17
Public Const SYN_PO_ADDRESS = 18
Public Const SYN_TIMESTAMP = 19
Public Const SYN_CLASS_NAME = 20
Public Const SYN_STREAM = 21
Public Const SYN_COUNTER = 22
Public Const SYN_BACK_LINK = 23
Public Const SYN_TIME = 24
Public Const SYN_TYPED_NAME = 25
Public Const SYN_HOLD = 26
Public Const SYN_INTERVAL = 27
Public Const SYN_COMPONENT = 28
Public Const SYN_ENUM_COMPONENT = 29
Public Const SYN_NULL = 30
Public Const SYN_OID = 31
Public Const SYN_ENUMERATED = 32
Public Const SYN_SET = 33
Public Const SYN_SEQUENCE = 34
Public Const SYN_CHOICE = 35
Public Const SYN_ANY = 36

Public Const FTOK_END = 0
Public Const FTOK_OR = 1
Public Const FTOK_AND = 2
Public Const FTOK_NOT = 3
Public Const FTOK_LPAREN = 4
Public Const FTOK_RPAREN = 5
Public Const FTOK_AVAL = 6
Public Const FTOK_EQ = 7
Public Const FTOK_GE = 8
Public Const FTOK_LE = 9
Public Const FTOK_APPROX = 10
Public Const FTOK_ANAME = 14
Public Const FTOK_PRESENT = 15
Public Const FTOK_RDN = 16
Public Const FTOK_BASECLS = 17
Public Const FTOK_MODTIME = 18
Public Const FTOK_VALTIME = 19

Type Object_Info_T
    objectFlags As Long
    subordinateCount As Long
    modificationTime As Long
    baseClass(66) As Byte
End Type



'(c)Novell


Declare Function NWCallsInit Lib "calwin32" _
    (reserved1 As Byte, reserved2 As Byte) As Long

Declare Function NWDSCreateContextHandle Lib "netwin32" _
    (context As Long) As Long

     
Declare Function NWDSSetContext Lib "netwin32" _
    (ByVal context As Long, ByVal key As Long, ByVal value As Long) As Long

Declare Function NWDSFreeContext Lib "netwin32" _
    (ByVal context As Long) As Long

Declare Function NWDSGetSyntaxID Lib "netwin32" _
    (ByVal context As Long, ByVal attrName As String, syntaxID As Long) As Long

Declare Function NWDSAllocBuf Lib "netwin32" _
    (ByVal size As Long, buf As Long) As Long

 Declare Function NWDSInitBuf Lib "netwin32" _
    (ByVal context As Long, ByVal operation As Long, _
     ByVal buf As Long) As Long

Declare Function NWDSFreeBuf Lib "netwin32" _
    (ByVal buf As Long) As Long

Declare Function NWDSGetObjectCount Lib "netwin32" _
    (ByVal context As Long, ByVal buf As Long, objectCount As Long) As Long

Declare Function NWDSGetObjectName Lib "netwin32" _
    (ByVal context As Long, ByVal buf As Long, _
     ByVal objectName As String, attrCount As Long, _
     objectInfo As Object_Info_T) As Long

Declare Function NWDSAllocFilter Lib "netwin32" _
    (cur As Long) As Long

Declare Function NWDSAddFilterToken Lib "netwin32" _
    (ByVal cur As Long, ByVal tok As Integer, _
     ByVal val As Long, ByVal syntax As Long) As Long

Declare Function NWDSDelFilterToken Lib "netwin32" _
    (ByVal cur As Long, ByVal functionPointer As Long) As Long

Declare Function NWDSPutFilter Lib "netwin32" _
    (ByVal context As Long, ByVal buf As Long, _
     ByVal cur As Long, ByVal funcPtr As Long) As Long

Declare Function NWDSSearch Lib "netwin32" _
    (ByVal context As Long, ByVal baseObjectName As String, _
     ByVal scope As Long, ByVal searchAliases As Byte, _
     ByVal filter As Long, ByVal infoType As Long, _
     ByVal allAttrs As Byte, ByVal attrNames As Long, _
     iterationHandle As Long, ByVal countObjectsToSearch As Long, _
     countObjectsSearched As Long, ByVal objectInfo As Long) As Long
     
     
     
'(c) Microsoft 1998

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Declare Function ShellExecute Lib _
    "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

Const SW_SHOWNORMAL = 1





Private Sub StringToByteArray(dest() As Byte, src As String)
Dim i As Integer
    For i = 0 To Len(src) - 1
        dest(i) = CByte(Asc(Mid(src, i + 1, 1)))
    Next i
End Sub

Public Sub GetServerList()
'****************************************************************
'*                                                              *
'* get Server List returns all servers (whether up or not)      *
'* in the tree defined in the GLOBAL conmst NDS_TREE                   *
'* in a Global Array ServersInTree, qty ServerCount             *
'*                                                              *
'****************************************************************


Dim retcode As Double, context As Long
Dim filterBuffer As Long, output As Long
Dim iteration As Long, objectCount As Long, attrCount As Long
Dim cursor As Variant, i As Long, syntaxID As Long
Dim criteria As Long, searched As Long
Dim otherInfo As Object_Info_T
Dim objName As String * 128
Dim byteName(127) As Byte
Dim byteName1(127) As Byte
Dim token() As TToken

openConn

' We start to inititate our token with all chosen values for "Object Class"
    ReDim token(0)
    Call StringToByteArray(token(0).buf, "Object Class" + chr(0))
    
    ReDim Preserve token(UBound(token) + 1)
    Call StringToByteArray(token(UBound(token)).buf, "NCP Server" + chr(0))
            
    'ListBox1.Clear
        
    retcode = NWDSCreateContextHandle(context)
' We have to set the DS tree name
    Call StringToByteArray(byteName, NDS_TREE + chr(0))
    retcode = NWDSSetContext(context, DCK_TREE_NAME, VarPtr(byteName(0)))
 
' The good habit is to set default context to [Root]
    Call StringToByteArray(byteName, DS_ROOT_NAME + chr(0))
    retcode = NWDSSetContext(context, DCK_NAME_CONTEXT, VarPtr(byteName(0)))
    retcode = NWDSAllocBuf(DEFAULT_MESSAGE_LEN, output)
    retcode = NWDSAllocBuf(DEFAULT_MESSAGE_LEN, filterBuffer)
    retcode = NWDSInitBuf(context, DSV_SEARCH_FILTER, filterBuffer)
    retcode = NWDSAllocFilter(cursor)

' Let`s feed now our filter with chosen values
' We are assembling  here basically something like the following expression:
'  (Object Class=User OR Object Class=Group OR...) AND (CN=ABC*)

    retcode = NWDSAddFilterToken(cursor, FTOK_LPAREN, 0, 0)
    For i = 1 To UBound(token)
    
        retcode = NWDSAddFilterToken(cursor, FTOK_ANAME, VarPtr(token(0).buf(0)), SYN_CLASS_NAME)
        retcode = NWDSAddFilterToken(cursor, FTOK_EQ, 0, 0)
        retcode = NWDSAddFilterToken(cursor, FTOK_AVAL, VarPtr(token(i).buf(0)), SYN_CLASS_NAME)
        retcode = NWDSAddFilterToken(cursor, FTOK_OR, 0, 0)
    Next i

' We have to delete last one FTOK_OR added in for-next loop
    retcode = NWDSDelFilterToken(cursor, 0)
    retcode = NWDSAddFilterToken(cursor, FTOK_RPAREN, 0, 0)
    
' Now we have to add search criteria for selected attribute and (sub)string
'  in case there is any input from user
    
        retcode = NWDSAddFilterToken(cursor, FTOK_AND, 0, 0)
        retcode = NWDSAddFilterToken(cursor, FTOK_LPAREN, 0, 0)
        
        

        retcode = NWDSGetSyntaxID(context, "Version" + chr(0), syntaxID)
        Call StringToByteArray(byteName, "Version" + chr(0))
        retcode = NWDSAddFilterToken(cursor, FTOK_ANAME, VarPtr(byteName(0)), syntaxID)
        retcode = NWDSAddFilterToken(cursor, FTOK_EQ, 0, 0)
        Call StringToByteArray(byteName1, "*.*" + chr(0))
' I ran into strange VB error on the code line below.
'  Using variable byteName here causes that wrong pointer
'  is passed to NWDSAddFilterToken - in fact pointer to previous FTOK_ANAME variable
'  The only workaround is to use different variable (!!!)
        retcode = NWDSAddFilterToken(cursor, FTOK_AVAL, VarPtr(byteName1(0)), syntaxID)
        retcode = NWDSAddFilterToken(cursor, FTOK_RPAREN, 0, 0)
  '  End If
    retcode = NWDSAddFilterToken(cursor, FTOK_END, 0&, 0)
    retcode = NWDSPutFilter(context, filterBuffer, cursor, 0)

' What search criteria did we select ?
        criteria = DS_SEARCH_SUBTREE
    Screen.MousePointer = vbHourglass
    iteration = NO_MORE_ITERATIONS
    Do
        AbendLogger.SwapIcon
' We want object names only, we don`t care about attributes...
        retcode = NWDSSearch(context, "[root]" + chr(0), criteria, _
                False, filterBuffer, DS_ATTRIBUTE_NAMES, _
                False, 0, iteration, 0, 0, output)
        If retcode = 0 Then
            retcode = NWDSGetObjectCount(context, output, objectCount)
            If (objectCount > 0) Then
                For i = 0 To objectCount - 1
                    retcode = NWDSGetObjectName(context, output, objName, attrCount, otherInfo)
                    If retcode = 0 Then
                        ReDim Preserve ServersInTree(ServerCount + 5)
                        objName = left$(objName, InStr(objName, chr$(0)) - 1)
                        objName = Mid$(objName, InStr(objName, "=") + 1)
                        objName = left$(objName, (InStr(objName, ".") - 1))
                        ServersInTree(ServerCount) = Trim$(objName)
                       Debug.Print objName; vbTab;
                       Debug.Print ServersInTree(i); vbTab;
                       Debug.Print "Array Var : "; ServerCount
                        ServerCount = ServerCount + 1
                        
                       
                    End If
                Next i
            End If
        Else
            Debug.Print "No such entry !"
        End If
' Let`s behave nicely and allow the system to do some other tasks
        DoEvents
    Loop While iteration <> NO_MORE_ITERATIONS
    Screen.MousePointer = vbDefault
    retcode = NWDSFreeBuf(output)
    retcode = NWDSFreeBuf(filterBuffer)
    retcode = NWDSFreeContext(context)
    CloseConn
End Sub




Function QuerySetValue(Qvalue As String) As Variant
Dim i As Integer
i = 0
Do
    If UCase$(Trim$(Qvalue)) = UCase$(Trim$(SetArrayStore(0, i))) Then
        QuerySetValue = SetArrayStore(1, i)
        Exit Do
    End If
    i = i + 1
    If i > NumSet Then Exit Do
Loop


Exit Function

End Function


 
Public Function ByteArrayToString(src() As Byte) As String

Dim dest As String
Dim i As Integer
i = 0
dest = ""
While src(i) <> 0
    dest = dest + chr(src(i))
    i = i + 1
Wend
ByteArrayToString = dest
End Function

Function CloseConn() As Long


' a connection should always be closed after...
CloseConn = NWCCCloseConn(rconnHandle)

End Function




Function EvaluateNWreturnCode(ccode As Long) As String
Select Case ccode
Case &H0 '
    EvaluateNWreturnCode = "SUCCESSFUL"
Case &H8801 '
    EvaluateNWreturnCode = "NWE_CONN_INVALID"
Case &H8808 '
    EvaluateNWreturnCode = "NWE_SERVER_NO_SLOTS"
Case &H880A '
    EvaluateNWreturnCode = "NWE_SERVER_NO_ROUTE"
Case &H883F '
    EvaluateNWreturnCode = "NWE_CONN_TABLE_FULL"
Case &H8841 '
    EvaluateNWreturnCode = "NWE_TRAN_INVALID_TYPE"
Case &H8847 '
    EvaluateNWreturnCode = "NWE_SERVER_NOT_FOUND"
Case &H8867 '
    EvaluateNWreturnCode = "NWE_INSUFFICIENT_RESOURCES"
Case &H8868 '
    EvaluateNWreturnCode = "NWE_STRING_TRANSLATION"
Case &H8869 '
    EvaluateNWreturnCode = "NWE_ACCESS_VIOLATION"
Case &H89FC
    EvaluateNWreturnCode = "Seems to be server not found"
Case &H89A8
        EvaluateNWreturnCode = "NWE_ACCESS_DENIED"
Case &H89DC
        EvaluateNWreturnCode = "NWE_ACCT_DISABLED: Attempt to log in using an account which has expired or has been disabled by the Supervisor."
Case &H89C4
        EvaluateNWreturnCode = "NWE_ACCTING_DISABLED"
Case &H89C1
        EvaluateNWreturnCode = "NWE_ACCTING_NO_ BALANCE: Attempted to log in by a bindery object without an accounting balance, and accounting is enabled."
Case &H89C2
        EvaluateNWreturnCode = "NWE_ACCTING_NO_CREDIT: Attempted to log in to account with no credit available."
Case &H89C0
        EvaluateNWreturnCode = "NWE_ACCTING_NO_PRIV"
Case &H89C3
        EvaluateNWreturnCode = "NWE_ACCTING_TOO_MANY_HOLDS"
Case &H89A6
        EvaluateNWreturnCode = "NWE_ALREADY_IN_USE or NWE_AUDITING_ACTIVE"
Case &H8983
        EvaluateNWreturnCode = "NWE_AUDITING_HARD_IO_ERROR"
Case &H89A8
        EvaluateNWreturnCode = "NWE_AUDITING_NO_RIGHTS"
Case &H8997
        EvaluateNWreturnCode = "NWE_AUDITING_NOT_ENABLED"
Case &H8984
        EvaluateNWreturnCode = "NWE_AUDITING_NOT_SUPV"
Case &H89C2
        EvaluateNWreturnCode = "NWE_AUDITING_RECORD_SIZE"
Case &H89FF
        EvaluateNWreturnCode = "NWE_BAD_RECORD_OFFSET or NWE_BAD_SPOOL_PRINTER"
Case &H89FE
        EvaluateNWreturnCode = "NWE_BIND_LOCKED"
Case &H89E9
        EvaluateNWreturnCode = "NWE_BIND_MEMBER_ALREADY_EXISTS: Attempt to redundantly add an object to a group property."
Case &H89EF
        EvaluateNWreturnCode = "NWE_BIND_NAME_INVALID: Request made with an object or property name containing illegal characters. Illegal characters in names are control characters, the comma, colon, semicolon, slash, backslash, question mark, asterisk, and tilde."
Case &H89EA
        EvaluateNWreturnCode = "NWE_BIND_NO_SUCH_MEMBER"
Case &H89FC
        EvaluateNWreturnCode = "NWE_BIND_NO_SUCH_OBJ: Attempt to use an object which doesn't exist, or the calling station doesn't have the proper security to access the object. Note that the object name and type must both match for the object to be found."
Case &H89FB
        EvaluateNWreturnCode = "NWE_BIND_NO_SUCH_PROP"
Case &H89EC
        EvaluateNWreturnCode = "NWE_BIND_NO_SUCH_SEGMENT: Attempt to use a nonexistent segment. Note that segments must be written sequentially when a property is first created, but may be read and written in any order after they already exist."
Case &H89EB
        EvaluateNWreturnCode = "NWE_BIND_NOT_GROUP_PROP: Attempt to use a non-group property."
Case &H89E8
        EvaluateNWreturnCode = "NWE_BIND_NOT_ITEM_PROP: Attempt to use an item not associated with this property group or an item which has been deleted from this group."
Case &H89EE
        EvaluateNWreturnCode = "NWE_BIND_OBJ_ALREADY_EXISTS"
Case &H89F5
        EvaluateNWreturnCode = "NWE_BIND_OBJ_NO_CREATE_PRIV: Attempt to create an object by a station without the necessary security to create or change an object. Only Supervisors are allowed to create objects."
Case &H89F4
        EvaluateNWreturnCode = "NWE_BIND_OBJ_NO_DELETE_PRIV: Attempt to delete an object by a station without the necessary security to delete the object. Only the Supervisor can delete objects. Note that if the station does not even have the proper security to see that the object exists, then NCP_NO_SUCH_OBJECT is returned."
Case &H89F2
        EvaluateNWreturnCode = "NWE_BIND_OBJ_NO_READ_PRIV: Attempt to access object information or scan the object's properties by a station without the necessary security to access this information."
Case &H89F3
        EvaluateNWreturnCode = "NWE_BIND_OBJ_NO_RENAME_PRIV: Attempt to rename an object without the necessary security. Only the Supervisor can rename objects. Note that if the station does not have the proper security to see that the object exists, then NCP_NO_SUCH_OBJECT is returned."
Case &H89ED
        EvaluateNWreturnCode = "NWE_BIND_PROP_ALREADY_EXISTS"
Case &H89F7
        EvaluateNWreturnCode = "NWE_BIND_PROP_NO_CREATE_PRIV: Attempt to create a property by a station without the necessary security to create or change a property for the object."
Case &H89F6
        EvaluateNWreturnCode = "NWE_BIND_PROP_NO_DELETE_PRIV: Attempt to delete a property by a station without the necessary security privilege to delete a property from the give object. Note that if the station does not have the proper security to see that the property exists, then NCP_NO_SUCH_PROPERTY is returned."
Case &H89F9
        EvaluateNWreturnCode = "NWE_BIND_PROP_NO_READ_PRIV: Attempt to read by a station without the necessary read security to access the property data."
Case &H89F8
        EvaluateNWreturnCode = "NWE_BIND_PROP_NO_WRITE_PRIV: Attempt to write by a station without the necessary write security to change the property data."
Case &H89F1
        EvaluateNWreturnCode = "NWE_BIND_SECURITY_INVALID: Attempt to assign a security level of a bindery object or property to be higher than the user's security level. This would make the object or property inaccessible to the user."
Case &H89F0
        EvaluateNWreturnCode = "NWE_BIND_WILDCARD_INVALID: Attempt to use a wildcard character or wild object type in a call where wildcards are not allowed."
Case &H89E8
        EvaluateNWreturnCode = "NWE_BIND_WRITE_TO_GROUP_PROP: Attempt to write a data segment to a group property using the call to write a property value."
Case &H8977
        EvaluateNWreturnCode = "NWE_BUFFER_TOO_SMALL"
Case &H897B
        EvaluateNWreturnCode = "NWE_CONN_ALREADY_LOGGED_IN"
Case &H897A
        EvaluateNWreturnCode = "NWE_CONN_ALREADY_TEMP"
Case &H897C
        EvaluateNWreturnCode = "NWE_CONN_NOT_AUTHENTICATED"
Case &H897D
        EvaluateNWreturnCode = "NWE_CONN_NOT_LOGGED_IN"
Case &H89FD
        EvaluateNWreturnCode = "NWE_CONN_NUM_INVALID: Attempt to use a bad (undefined, unavailable, etc.) station number."
Case &H89C6
        EvaluateNWreturnCode = "NWE_CONSOLE_NO_PRIV: Attempt to use console without operator privileges."
Case &H89BE
        EvaluateNWreturnCode = "NWE_DATA_STREAM_INVALID"
Case &H899F
        EvaluateNWreturnCode = "NWE_DIR_ACTIVE: Attempted to delete a directory that is being used by another workstation."
Case &H8999
        EvaluateNWreturnCode = "NWE_DIR_FULL"
Case &H89A1
        EvaluateNWreturnCode = "NWE_DIR_IO_ERROR: A nonrecoverable I/O error has occurred on the disk in the directory area. This error has occurred in both copies of the directory and is fatal."
Case &H89FE
        EvaluateNWreturnCode = "NWE_DIR_LOCKED"
Case &H89A0
        EvaluateNWreturnCode = "NWE_DIR_NOT_EMPTY"
Case &H89A4
        EvaluateNWreturnCode = "NWE_DIR_RENAME_INVALID"
Case &H8996
        EvaluateNWreturnCode = "NWE_DIR_TARGET_INVALID"
Case &H899B
        EvaluateNWreturnCode = "NWE_DIRHANDLE_INVALID: Attempted to use an invalid directory handle. This occurs if the network has been brought down and brought back up without rebooting the workstation."
Case &H899D
        EvaluateNWreturnCode = "NWE_DIRHANDLE_NO_MORE: No more directory handles available; the directory handle table is full. Each user may have up to 255 directory handles."
Case &H8983
        EvaluateNWreturnCode = "NWE_DISK_IO_ERROR: Hard disk input/output error on a NetWare volume; a bad sector has been encountered and could be fatal."
Case &H8997
        EvaluateNWreturnCode = "NWE_DISK_NO_SPOOL_SPACE: The network operating system has determined that the network disk doesn't have enough space left for spool files."
Case &H89FF
        EvaluateNWreturnCode = "NWE_DRIVE_INVALID_NUM"
Case &H89E7
        EvaluateNWreturnCode = "NWE_E_NO_MORE_USERS"
Case &H89FF
        EvaluateNWreturnCode = "NWE_FAILURE: Generic Failure or NWE_FCB_CLOSE"
Case &H8995
        EvaluateNWreturnCode = "NWE_FILE_DETACHED: Attempted to read or write to a detached file."
Case &H8986
        EvaluateNWreturnCode = "NWE_FILE_EXISTS_READ_ONLY: Attempted to create a file with the same name as an already existing file with read-only status."
Case &H89FF
        EvaluateNWreturnCode = "NWE_FILE_EXT"
Case &H8980
        EvaluateNWreturnCode = "NWE_FILE_IN_USE: Attempted to open or create an already open file."
Case &H8988
        EvaluateNWreturnCode = "NWE_FILE_INVALID_HANDLE: Attempted to close or perform an I/O on a file with an invalid file handle (i.e. trying to read from a file that has been closed)."
Case &H89A2
        EvaluateNWreturnCode = "NWE_FILE_IO_LOCKED: Attempted to read a file where data is physically locked."
Case &H89FF
        EvaluateNWreturnCode = "NWE_FILE_NAME"
Case &H899E
        EvaluateNWreturnCode = "NWE_FILE_NAME_INVALID: Attempted to create a file using invalid characters in the file name."
Case &H8985
        EvaluateNWreturnCode = "NWE_FILE_NO_CREATE_DEL_PRIV: Attempted to create an already existing file without create/delete privileges."
Case &H8984
        EvaluateNWreturnCode = "NWE_FILE_NO_CREATE_PRIV: Attempted to create a file without the create privilege."
Case &H898A
        EvaluateNWreturnCode = "NWE_FILE_NO_DEL_PRIV: Attempted to delete a file without file deletion privileges in that file's directory."
Case &H8981
        EvaluateNWreturnCode = "NWE_FILE_NO_HANDLES: No more file handles available; the network file handle table is full."
Case &H898C
        EvaluateNWreturnCode = "NWE_FILE_NO_MOD_PRIV: Attempted to modify a file without attribute modification privileges in that file's directory."
Case &H8982
        EvaluateNWreturnCode = "NWE_FILE_NO_OPEN_PRIV: Attempted to open a file without the open privilege."
Case &H8993
        EvaluateNWreturnCode = "NWE_FILE_NO_READ_PRIV: Attempted to read a file without read privileges to that file."
Case &H898B
        EvaluateNWreturnCode = "NWE_FILE_NO_RENAME_PRIV: Attempted to rename a file without renaming privileges in that file's directory."
Case &H8989
        EvaluateNWreturnCode = "NWE_FILE_NO_SRCH_PRIV: Attempted to search a directory without search privileges in that directory."
Case &H8994
        EvaluateNWreturnCode = "NWE_FILE_NO_WRITE_PRIV: Attempted to write to a file without write privileges to that file."
Case &H898E
        EvaluateNWreturnCode = "NWE_FILE_NONE_IN_USE: Attempted to delete, rename, or set file attributes using an ambiguous filename while some of the files specified by the filename are in use by another workstation."
Case &H8990
        EvaluateNWreturnCode = "NWE_FILE_NONE_READ_ONLY: Attempted to delete, rename, or set file attributes using a filename when all of the files specified have read-only status."
Case &H8992
        EvaluateNWreturnCode = "NWE_FILE_NONE_RENAMED_EXIST: Attempted to rename a file using a filename, when all of the files matching the new filename specification already exist."
Case &H89A5
        EvaluateNWreturnCode = "NWE_FILE_OPENCREAT_MODE_INVALID"
Case &H8994
        EvaluateNWreturnCode = "NWE_FILE_READ_ONLY: the specified file has read-only status."
Case &H898D
        EvaluateNWreturnCode = "NWE_FILE_SOME_IN_USE: Attempted to delete, rename, or set file attributes using an ambiguous filename while some of the files specified by the filename are in use by another workstation."
Case &H898F
        EvaluateNWreturnCode = "NWE_FILE_SOME_READ_ONLY: Attempted to delete, rename, or set file attributes using a filename when some of the files specified have read-only status."
Case &H8991
        EvaluateNWreturnCode = "NWE_FILE_SOME_RENAMED_EXIST: Attempted to rename files using an ambiguous filename, when one or more files matching the new filename specification already exist."
Case &H8987
        EvaluateNWreturnCode = "NWE_FILE_WILD_CARDS_IN_NAME: Attempted to create a file using an ambiguous filename."
Case &H89FF
        EvaluateNWreturnCode = "NWE_HARD_FAILURE"
Case &H89FC
        EvaluateNWreturnCode = "NWE_INET_PACKET_REQ_CANCELED"
Case &H8901
        EvaluateNWreturnCode = "NWE_INSUFFICIENT_SPACE"
Case &H89FF
        EvaluateNWreturnCode = "NWE_IO_BOUND"
Case &H89FD
        EvaluateNWreturnCode = "NWE_LOCK_COLLISION"
Case &H89FF
        EvaluateNWreturnCode = "NWE_LOCK_ERROR"
Case &H8980
        EvaluateNWreturnCode = "NWE_LOCK_FAIL"
Case &H897F
        EvaluateNWreturnCode = "NWE_LOCK_WAITING"
Case &H89FE
        EvaluateNWreturnCode = "NWE_LOGIN_DISABLED_BY_SUPER"
Case &H89C5
        EvaluateNWreturnCode = "NWE_LOGIN_LOCKOUT: Attempt to log in after the system had locked the account because of intruder detection."
Case &H89D9
        EvaluateNWreturnCode = "NWE_LOGIN_MAX_EXCEEDED or NWE_LOGIN_NO_CONN"
Case &H89E0
        EvaluateNWreturnCode = "NWE_LOGIN_NO_CONN_AVAIL"
Case &H89DB
        EvaluateNWreturnCode = "NWE_LOGIN_UNAUTHORIZED_STATION: Attempt to log in from an unauthorized station using an account with limits to a specific network and/or station."
Case &H89DA
        EvaluateNWreturnCode = "NWE_LOGIN_UNAUTHORIZED_TIME"
Case &H89FC
        EvaluateNWreturnCode = "NWE_MSG_Q_FULL"
Case &H89BF
        EvaluateNWreturnCode = "NWE_NAME_SPACE_INVALID"
Case &H897E
        EvaluateNWreturnCode = "NWE_NCP_BOUNDARY_CHECK_FAILED"
Case &H89FB
        EvaluateNWreturnCode = "NWE_NCP_NOT_SUPPORTED"
Case &H89FF
        EvaluateNWreturnCode = "NWE_NO_FILES_FOUND_ERROR"
Case &H89F9
        EvaluateNWreturnCode = "NWE_NO_FREE_CONN_SLOTS"
Case &H8979
        EvaluateNWreturnCode = "NWE_NO_ITEMS_FOUND"
Case &H89FA
        EvaluateNWreturnCode = "NWE_NO_MORE_SERVER_SLOTS"
Case &H89FF
        EvaluateNWreturnCode = "NWE_NO_OBJ_OR_BAD_PASSWORD or NWE_NO_RESPONSE_FROM_SERVER"
Case &H89FD
        EvaluateNWreturnCode = "NWE_PACKET_LEN_INVALID: The requesting packet did not have a 30 byte packet header as the first fragment, or its total length exceeded 576 characters."
Case &H89FE
        EvaluateNWreturnCode = "NWE_PACKET_NOT_DELIVERABLE"
Case &H89FB
        EvaluateNWreturnCode = "NWE_PARAMETERS_INVALID: Attempt to use an invalid parameter (drive number, path, or flag value) during a set drive path call."
Case &H89DF
        EvaluateNWreturnCode = "NWE_PASSWORD_EXPIRED: Attempt to log in using an expired account password but the login was allowed because the account had a grace login."
Case &H89DE
        EvaluateNWreturnCode = "NWE_PASSWORD_INVALID: Attempt to log in using an account password which has expired and all grace logins have also expired."
Case &H89D7
        EvaluateNWreturnCode = "NWE_PASSWORD_NOT_UNIQUE: Attempt to change password to a previously used password when the unique requirement is specified for the account."
Case &H89D8
        EvaluateNWreturnCode = "NWE_PASSWORD_TOO_SHORT: Attempt to change password to a password with fewer characters than the required minimum specified for the account."
Case &H89D6
        EvaluateNWreturnCode = "NWE_PASSWORD_UNENCRYPTED"
Case &H899C
        EvaluateNWreturnCode = "NWE_PATH_INVALID"
Case &H89FF
        EvaluateNWreturnCode = "NWE_PATH_NOT_LOCATABLE"
Case &H89D4
        EvaluateNWreturnCode = "NWE_Q_FULL"
Case &H89FF
        EvaluateNWreturnCode = "NWE_Q_FULL_ERROR"
Case &H89DA
        EvaluateNWreturnCode = "NWE_Q_HALTED"
Case &H89D7
        EvaluateNWreturnCode = "NWE_Q_IN_SERVICE"
Case &H89D0
        EvaluateNWreturnCode = "NWE_Q_IO_FAILURE"
Case &H89DB
        EvaluateNWreturnCode = "NWE_Q_MAX_SERVERS"
Case &H89D5
        EvaluateNWreturnCode = "NWE_Q_NO_JOB"
Case &H89D6
        EvaluateNWreturnCode = "NWE_Q_NO_JOB_RIGHTS"
Case &H89D3
        EvaluateNWreturnCode = "NWE_Q_NO_RIGHTS"
Case &H89D2
        EvaluateNWreturnCode = "NWE_Q_NO_SERVER"
Case &H89D1
        EvaluateNWreturnCode = "NWE_Q_NONE"
Case &H89D8
        EvaluateNWreturnCode = "NWE_Q_NOT_ACTIVE"
Case &H89D9
        EvaluateNWreturnCode = "NWE_Q_STN_NOT_SERVER"
Case &H89FF
        EvaluateNWreturnCode = "NWE_REQ_NOT_OUTSTANDING"
Case &H89A7
        EvaluateNWreturnCode = "NWE_RESOURCE_TAG_INVALID"
Case &H89FF
        EvaluateNWreturnCode = "NWE_SEM_INVALID_HANDLE or NWE_SEM_INVALID_INIT_VAL"
Case &H89FE
        EvaluateNWreturnCode = "NWE_SEM_INVALID_NAME_LEN"
Case &H8996
        EvaluateNWreturnCode = "NWE_SERVER_OUT_OF_MEMORY: Attempted to write to a server that does not currently have enough free DRAM to process this request."
Case &H89FC
        EvaluateNWreturnCode = "NWE_SERVER_UNKNOWN: Attempt to attach to a server using an invalid server name."
Case &H89FF
        EvaluateNWreturnCode = "NWE_SOCKET_ALREADY_OPEN"
Case &H89FE
        EvaluateNWreturnCode = "NWE_SOCKET_TABLE_FULL or NWE_SPOOL_DIR_ERROR"
Case &H89FA
        EvaluateNWreturnCode = "NWE_TEMP_REMAP_ERROR: Attempt to use an unknown path."
Case &H89FE
        EvaluateNWreturnCode = "NWE_TIMEOUT_FAILURE or NWE_TRUSTEE_NOT_FOUND"
Case &H899C
        EvaluateNWreturnCode = "NWE_TRUSTEES_NO_MORE: No more trustees are listed in the directory."
Case &H89A3
        EvaluateNWreturnCode = "NWE_TTS_RANSACTION_RESTARTED or NWE_TTS_TRANSACTION_RESTARTED"
Case &H89FD
        EvaluateNWreturnCode = "NWE_UNKNOWN_REQ"
Case &H8978
        EvaluateNWreturnCode = "NWE_VOL_FLAG_NOT_SET: The service requested is not available on the selected volume."
Case &H8998
        EvaluateNWreturnCode = "NWE_VOL_INVALID: The network operating system has tried to access a volume but cannot find the volume in the system definition files."
Case &H899A
        EvaluateNWreturnCode = "NWE_VOL_RENAMING_ACROSS: Attempted to rename a file and move the renamed file from its current volume into another volume. The rename command may move the file between directories on the same volume; however, using rename to move a file between volumes is not allowed."
Case &H89EE
        EvaluateNWreturnCode = "OBJECT_ALREADY_EXISTS"
Case &H89FE
        EvaluateNWreturnCode = "PACKET_NOT_DELIVERABLE"
Case &H89DF
        EvaluateNWreturnCode = "PASSWORD_HAS_EXPIRED: Attempt to log in using an expired account password but the login was allowed because the account had a grace login."
Case &H89DE
        EvaluateNWreturnCode = "PASSWORD_HAS_EXPIRED_NO_GRACE: Attempt to log in using an account password which has expired and all grace logins have also expired."
Case &H89D7
        EvaluateNWreturnCode = "PASSWORD_NOT_UNIQUE: Attempt to change password to a previously used password when the unique requirement is specified for the account."
Case &H89D8
        EvaluateNWreturnCode = "PASSWORD_TOO_SHORT: Attempt to change password to a password with fewer characters than the required minimum specified for the account."
Case &H89FF
        EvaluateNWreturnCode = "PATH_NOT_LOCATABLE"
Case &H89ED
        EvaluateNWreturnCode = "PROPERTY_ALREADY_EXISTS"
Case &H89FF
        EvaluateNWreturnCode = "QUEUE_FULL_ERROR"
Case &H89A2
        EvaluateNWreturnCode = "READ_FILE_WITH_RECORD_LOCKED: Attempted to read a file where data is physically locked."
Case &H899A
        EvaluateNWreturnCode = "RENAMING_ACROSS_VOLUMES: Attempted to rename a file and move the renamed file from its current volume into another volume. The rename command may move the file between directories on the same volume; however, using rename to move a file between volumes is not allowed."
Case &H89FF
        EvaluateNWreturnCode = "REQUEST_NOT_OUTSTANDING"
Case &H89FE
        EvaluateNWreturnCode = "SERVER_BINDERY_LOCKED"
Case &H8996
        EvaluateNWreturnCode = "SERVER_OUT_OF_MEMORY: Attempted to write to a server that does not currently have enough free DRAM to process this request."
Case &H89FF
        EvaluateNWreturnCode = "SOCKET_ALREADY_OPEN"
Case &H89FE
        EvaluateNWreturnCode = "SOCKET_TABLE_FULL"
Case &H898D
        EvaluateNWreturnCode = "SOME_FILES_AFFECTED_IN_USE: Attempted to delete, rename, or set file attributes using an ambiguous filename while some of the files specified by the filename are in use by another workstation."
Case &H898F
        EvaluateNWreturnCode = "SOME_FILES_AFFECTED_READ_ONLY: Attempted to delete, rename, or set file attributes using a filename when some of the files specified have read-only status."
Case &H8991
        EvaluateNWreturnCode = "SOME_FILES_RENAMED_NAME_EXISTS: Attempted to rename files using an ambiguous filename, when one or more files matching the new filename specification already exist."
Case &H89FE
        EvaluateNWreturnCode = "SPOOL_DIRECTORY_ERROR or SUPERVISOR_HAS_DISABLED_LOGIN"
Case &H89F7
        EvaluateNWreturnCode = "TARGET_DRIVE_NOT_LOCAL"
Case &H89FA
        EvaluateNWreturnCode = "TEMP_REMAP_ERROR: Attempt to use an unknown path."
Case &H89FE
        EvaluateNWreturnCode = "TIMEOUT_FAILURE or TRUSTEE_NOT_FOUND"
Case &H89DB
        EvaluateNWreturnCode = "UNAUTHORIZED_LOGIN_STATION: Attempt to log in from an unauthorized station using an account with limits to a specific network and/or station."
Case &H89DA
        EvaluateNWreturnCode = "UNAUTHORIZED_LOGIN_TIME"
Case &H89FC
        EvaluateNWreturnCode = "UNKNOWN_FILE_SERVER: Attempt to attach to a server using an invalid server name."
Case &H89FD
        EvaluateNWreturnCode = "UNKNOWN_REQUEST"
Case &H203
        EvaluateNWreturnCode = "VOLUME_ALREADY_MOUNTED: Unable to mount specified"
Case &H8998
        EvaluateNWreturnCode = "VOLUME_DOES_NOT_EXIST: The network operating system has tried to access a volume but cannot find the volume in the system definition files."
Case &H89F0
        EvaluateNWreturnCode = "WILD_CARD_NOT_ALLOWED: Attempt to use a wildcard character or wild object type in a call where wildcards are not allowed."
Case &H8987
        EvaluateNWreturnCode = "WILD_CARDS_IN_CREATE_FILE_NAME: Attempted to create a file using an ambiguous filename."
Case &H89E8
        EvaluateNWreturnCode = "WRITE_PROPERTY_TO_GROUP: Attempt to write a data segment to a group property using the call to write a property value."



Case Else
    EvaluateNWreturnCode = "Return Code " & Hex(ccode) & " not understood"
End Select
End Function

Sub openConn()
Dim ccode As Long
ccode = NWCallsInit(0, 0)
End Sub



